from emod_api import schema_to_class as s2c
import json
import pdb

schema_path = None

def basicEmergenceEvent(genome=7, clade=0, start_day=1, nods=[]): 
    event = s2c.get_class_with_defaults( "CampaignEvent", schema_path )
    coordinator = s2c.get_class_with_defaults( "StandardInterventionDistributionEventCoordinator", schema_path )
    if coordinator is None:
        print( "s2c.get_class_with_defaults returned None. Maybe no schema.json was provided." )
        return ""
    try:
        coordinator.Max_Cases_Per_Node = cases
    except Exception as ex:
        # This can be fine because this is a new parameter only in some branches.
        # Obviously this question is more general and needs a better general solution
        # if at all possible. Max_Cases_Per_Node is an event coordinator optional param.
        print( str( ex ) ) 
    
    event.Event_Coordinator_Config = coordinator
    # The intervention itself should be reused from another module
    intervention = s2c.get_class_with_defaults( "Outbreak", schema_path )
    intervention.Genome=genome
    intervention.Clade=clade
    intervention.Import_Age=5*365
    intervention.Number_Cases_Per_Node=20

    coordinator.Intervention_Config = intervention
    event.Start_Day = float(start_day)

    if len(nods) > 0:
        nodelist = s2c.get_class_with_defaults( "NodeSetNodeList", schema_path )
        nodelist.Node_List = nods
        event.Nodeset_Config = nodelist
        nodelist.finalize()

    coordinator.finalize()
    intervention.finalize()
    event.finalize()
    #event["Event_Name"] = Event_Name

    return event

